//
//  MistTaskState.swift
//  Mist
//
//  Created by Nindi Gill on 17/6/2022.
//

import SwiftUI

enum MistTaskState: String {
    case pending = "Pending"
    case inProgress = "In Progress"
    case complete = "Complete"
    case error = "Error"

    var imageName: String {
        switch self {
        case .pending:
            return "hourglass.circle.fill"
        case .inProgress:
            return "gear.circle.fill"
        case .complete:
            return "checkmark.circle.fill"
        case .error:
            return "xmark.circle.fill"
        }
    }

    var color: Color {
        switch self {
        case .pending:
            return .orange
        case .inProgress:
            return .blue
        case .complete:
            return .green
        case .error:
            return .red
        }
    }
}
